/***********************************************************************

            BALANZA USB - (C) 2001

			TECNICAS DIGITALES III

  Profesor: Ing Furfaro
  Curso: 5 53

  Grupo

		Martin Mirko
		Claudio Santarsieri
	    Gaston Vainer

  Aplicacion creada con VISUAL C++ 6.0 de Microsoft usando MFC 

  debe estar el archivo MFC42.dll en /Windows/system
  
  Ademas para compilarlo colocar esta carpeta en 

  C:\Archivos de programa\Thesycon\USBIO_Demo\V1.42\source

  y observar en project settings , los directorios para las librerias USBIOlib
  

/***********************************************************************/



#include "stdafx.h"
#include "balanzausb.h"
#include "balanzausbDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#ifndef WIN32_LEAN_AND_MEAN
#define WIN32_LEAN_AND_MEAN 1
#endif



/********************************** Includes *****************************/
// Windows
#include <windows.h>
#include "UsbIoPipe.h"

#define NB_OF_BUFFERS   1
#define CONFIG_INDEX  0
#define CONFIG_NB_OF_INTERFACES   1
#define CONFIG_INTERFACE    0
#define CONFIG_ALT_SETTING  0
#define CONFIG_MAX_SIZE   16

#define ENDPOINT_ADDRESS1 0x81
#define ENDPOINT_ADDRESS2 0x02

#define USB_VENDOR_ID   0x0C70
#define USB_PRODUCT_ID  0x0000

// GLOBALES

GUID g_UsbioID = USBIO_IID;
HDEVINFO g_DevList = NULL;

CUsbIo Disp;					
CUsbIoPipe PipeIn,PipeOut;     // handles de los pipes
CUsbIoBuf BufferRead (8); //declaro un buffer de 8 bytes
CUsbIoBuf BufferWrite (16); //declaro un buffer de 16 bytes
unsigned char *ptr;

int NumDisp = -1;
float coef;
unsigned char cero;
bool configurado=false,grabar = false;


/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{

public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBalanzausbDlg dialog

CBalanzausbDlg::CBalanzausbDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CBalanzausbDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CBalanzausbDlg)
	m_sCuentas = _T("");
	m_sPeso = _T("");
	m_sStatus = _T("");
	m_PesoPat = 190;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_lim[0] = 20;
	m_lim[1] = 20;
	m_lim[2] = 20;
	m_lim[3] = 20;
	m_lim[4] = 20;
	m_lim[5] = 20;
	m_lim[6] = 20;
	m_lim[7] = 20;

	InitEstad();

	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CBalanzausbDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CBalanzausbDlg)
	DDX_Control(pDX, IDC_REEMPEZAR, m_BReempezar);
	DDX_Control(pDX, IDC_GUARD_LIM, m_BGuardaLim);
	DDX_Control(pDX, IDC_EMPEZAR, m_BEmpezarTrabajo);
	DDX_Control(pDX, IDC_CAL, m_BCalib);
	DDX_Control(pDX, IDC_PRUEBA, m_BPrueba);
	DDX_Control(pDX, IDC_STOP_TRABAJO, m_BPararTrabajo);
	DDX_Control(pDX, IDC_STOP_CAL, m_BPararPrueba);
	DDX_Text(pDX, IDC_CUENTAS, m_sCuentas);
	DDX_Text(pDX, IDC_PESO, m_sPeso);
	DDX_Text(pDX, IDC_STATUS, m_sStatus);
	DDX_Text(pDX, IDC_EDIT9, m_PesoPat);
	DDV_MinMaxInt(pDX, m_PesoPat, 150, 600);
	//}}AFX_DATA_MAP

	// Inicializo limites en pantalla
	
	DDX_Text(pDX, IDC_EDIT1, m_lim[0]);
	DDX_Text(pDX, IDC_EDIT2, m_lim[1]);
	DDX_Text(pDX, IDC_EDIT3, m_lim[2]);
	DDX_Text(pDX, IDC_EDIT4, m_lim[3]);
	DDX_Text(pDX, IDC_EDIT5, m_lim[4]);
	DDX_Text(pDX, IDC_EDIT6, m_lim[5]);
	DDX_Text(pDX, IDC_EDIT7, m_lim[6]);
	DDX_Text(pDX, IDC_EDIT8, m_lim[7]);

	// Compruebo limite maximo y minimo a introducir

	DDV_MinMaxShort(pDX, m_lim[0], 20, 800);
	DDV_MinMaxShort(pDX, m_lim[1], 20, 800);
	DDV_MinMaxShort(pDX, m_lim[2], 20, 800);
	DDV_MinMaxShort(pDX, m_lim[3], 20, 800);
	DDV_MinMaxShort(pDX, m_lim[4], 20, 800);
	DDV_MinMaxShort(pDX, m_lim[5], 20, 800);
	DDV_MinMaxShort(pDX, m_lim[6], 20, 800);
	DDV_MinMaxShort(pDX, m_lim[7], 20, 800);
	
	// Inicializo valores de estadistica en pantalla

	DDX_Text(pDX, IDC_CANT1, m_sCant[0]);
	DDX_Text(pDX, IDC_CANT2, m_sCant[1]);
	DDX_Text(pDX, IDC_CANT3, m_sCant[2]);
	DDX_Text(pDX, IDC_CANT4, m_sCant[3]);
	DDX_Text(pDX, IDC_CANT5, m_sCant[4]);
	DDX_Text(pDX, IDC_CANT6, m_sCant[5]);
	DDX_Text(pDX, IDC_CANT7, m_sCant[6]);
	DDX_Text(pDX, IDC_CANT8, m_sCant[7]);
	DDX_Text(pDX, IDC_CANT_TOT, m_sCant[8]);
	DDX_Text(pDX, IDC_PESO1, m_sGramos[0]);
	DDX_Text(pDX, IDC_PESO2, m_sGramos[1]);
	DDX_Text(pDX, IDC_PESO3, m_sGramos[2]);
	DDX_Text(pDX, IDC_PESO4, m_sGramos[3]);
	DDX_Text(pDX, IDC_PESO5, m_sGramos[4]);
	DDX_Text(pDX, IDC_PESO6, m_sGramos[5]);
	DDX_Text(pDX, IDC_PESO7, m_sGramos[6]);
	DDX_Text(pDX, IDC_PESO8, m_sGramos[7]);
	DDX_Text(pDX, IDC_PESO_TOT, m_sGramos[8]);
	
}

BEGIN_MESSAGE_MAP(CBalanzausbDlg, CDialog)
	//{{AFX_MSG_MAP(CBalanzausbDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_EXIT, OnExit)
	ON_BN_CLICKED(IDC_CAL, OnCal)
	ON_BN_CLICKED(IDC_PRUEBA, OnPrueba)
	ON_BN_CLICKED(IDC_STOP_CAL, OnStopCal)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_GUARD_LIM, OnGuardLim)
	ON_BN_CLICKED(IDC_CARGA_LIM, OnCargaLim)
	ON_BN_CLICKED(IDC_GUAR_ESTAD, OnGuarEstad)
	ON_BN_CLICKED(IDC_EMPEZAR, OnEmpezar)
	ON_BN_CLICKED(IDC_STOP_TRABAJO, OnStopTrabajo)
	ON_BN_CLICKED(IDC_REEMPEZAR, OnReempezar)
	ON_BN_CLICKED(IDC_RESET_ESTAD, OnResetEstad)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBalanzausbDlg message handlers

BOOL CBalanzausbDlg::OnInitDialog()
{
	char status;

	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	
	status=InitUsb(); // Inicializacion del dispositivo USB
	
	switch(status)
	{
	// Si status es 0 , el dispositivo fue encontrado

	case 0:						
			status=ConfDisp();  // Ahora lo configuro y abro pipes
			switch(status)			
			{
			case 0:  // OK
				MessageBox("Dispositivo Encontrado y Configurado!","Balanza USB",MB_OK | MB_ICONINFORMATION);
				
				if (!Configurar())
					MessageBox("No se encontro el archivo de configuracion, deber calibrar la balanza y cargar los limites antes de empezar","Configuracin",MB_OK | MB_ICONSTOP);
				else 
				{	m_BEmpezarTrabajo.EnableWindow(TRUE);	
					m_BGuardaLim.EnableWindow(TRUE);
				}
				configurado=true;
				break;			
			case 1:  // No pudo abrirlo
				MessageBox("No se pudo abrir el dispositivo","Balanza USB",MB_OK | MB_ICONSTOP);
				OnExit();
				break;
			case 2: // No pudo configurarlo
				MessageBox("No se pudo configurar el dispositivo","Balanza USB",MB_OK | MB_ICONSTOP);
				OnExit();
				break;
			case 3: // No pudo bindear pipe 0x81 (IN)
				MessageBox("No se pudo bindear el pipe 0x81","Balanza USB",MB_OK | MB_ICONSTOP);
				OnExit();
				break;
			case 4: // No pudo bindear pipe 0x02 (OUT)
				MessageBox("No se pudo bindear el pipe 0x02","Balanza USB",MB_OK | MB_ICONSTOP);
				OnExit();
				break;
			}
			break;	
	
	case 1: 
			MessageBox("No se pudo crear una lista de dispositivos","Balanza USB",MB_OK | MB_ICONSTOP);
			OnExit();
			break;
	case 2: 
			MessageBox("Fallo el GetDescriptor","Balanza USB",MB_OK | MB_ICONSTOP);
			OnExit();
			break;
	case 3: 
	    	MessageBox("No hay dispositivos USB conectados!","Balanza USB",MB_OK | MB_ICONSTOP);
			OnExit();
			break;
	}
	
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CBalanzausbDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CBalanzausbDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.

HCURSOR CBalanzausbDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}


/* RUTINA DE INICIALIZACION DEL DISPOSITIVO USB */

char CBalanzausbDlg::InitUsb()
{
  CUsbIo UsbDev;
  USB_DEVICE_DESCRIPTOR DevDesc;  
  DWORD Status;
  char DispOK=3;

  // Buscando dispositivos conectados
  g_DevList = CUsbIo::CreateDeviceList(&g_UsbioID);
  if ( g_DevList==NULL ) 
  {
    DispOK=1;
    return DispOK;
  }

  // Abro los dispositivos uno a uno 
  for ( int i=0; i<127; i++ ) 
  {
    
    Status = UsbDev.Open(i,g_DevList,&g_UsbioID);
    if ( Status != USBIO_ERR_SUCCESS ) 
	{
	// no hay mas disp , salgo	
      break;
    }
    // leo el descriptor
    Status = UsbDev.GetDeviceDescriptor(&DevDesc);
    // cierro el dispositivo
	UsbDev.Close();
    // busco el dispositivo deseado segun su VENDOR ID y PRODUCT ID
    if ( DevDesc.idVendor==USB_VENDOR_ID && DevDesc.idProduct==USB_PRODUCT_ID   ) 
		{
		NumDisp = i;
		DispOK = 0;
		break; // Dispositivo encontrado , salgo del loop
		}
     
	else 
		{
		// Fallo el GetDescriptor
		DispOK = 2;
		}
  } 
  return DispOK;
}

/* RUTINA DE CONFIGURACION DEL DISPOSITIVO USB */

char CBalanzausbDlg::ConfDisp()
{
  USBIO_SET_CONFIGURATION Conf;
  DWORD Status;
  

  // abro el dispositivo
  Status = Disp.Open(NumDisp,g_DevList,&g_UsbioID);
  if ( Status != USBIO_ERR_SUCCESS ) 
  {      
	  return 1;
  }

  // setup de SetConfiguration
  ZeroMemory(&Conf,sizeof(Conf));
  Conf.ConfigurationIndex = CONFIG_INDEX;
  Conf.NbOfInterfaces = CONFIG_NB_OF_INTERFACES;
  Conf.InterfaceList[0].InterfaceIndex = CONFIG_INTERFACE;
  Conf.InterfaceList[0].AlternateSettingIndex = CONFIG_ALT_SETTING;
  Conf.InterfaceList[0].MaximumTransferSize = CONFIG_MAX_SIZE;
  // configurando el dispositivo
  Status = Disp.SetConfiguration(&Conf);
  if ( Status != USBIO_ERR_SUCCESS ) 
  {
    return 2;
  }
  

  // Abro los pipes y los bindeo
  Status = PipeIn.Bind(NumDisp,ENDPOINT_ADDRESS1,g_DevList,&g_UsbioID);
  if ( Status != USBIO_ERR_SUCCESS ) 
  {
    // No pudo bindearse el pipe 0x81
    return 3;
  }

  Status = PipeOut.Bind(NumDisp,ENDPOINT_ADDRESS2,g_DevList,&g_UsbioID);
  if ( Status != USBIO_ERR_SUCCESS ) 
  {
    // No pudo bindearse el pipe 0x81
    return 4;
  }

  return 0; // se abrio ok
}

/* Rutina para leer el peso en forma estatica , envia comando y luego lee */

unsigned char CBalanzausbDlg::LeoPesoEst()
{
  DWORD Status;
  char *ptr1;
  unsigned char *ptr2 ;
  unsigned char peso;
  
  ptr1 = (char*)BufferRead.Buffer();
  ptr2 = (unsigned char*)BufferWrite.Buffer();

  BufferWrite.NumberOfBytesToTransfer = 16;
  // Envio Comando de pesar = 1
  *ptr2 = 1;
  PipeOut.Write(&BufferWrite);

  Status = PipeOut.WaitForCompletion(&BufferWrite,200);

  if (Status == USBIO_ERR_SUCCESS) 
  {
	BufferRead.NumberOfBytesToTransfer = 8;
	PipeIn.Read(&BufferRead);
	Status = PipeIn.WaitForCompletion(&BufferRead,200);
  // si status = ok , leo el valor
	if (Status == USBIO_ERR_SUCCESS) 
	{
	peso = *(ptr1+1);  
	}

  }	

return peso;

}

/* Rutina para leer el dispositivo , llena el buffer de lectura y sale */

bool CBalanzausbDlg::LeoUsb()
{
  
  DWORD Status;
  
  ptr = (unsigned char*)BufferRead.Buffer();
  
  BufferRead.NumberOfBytesToTransfer = 8;
  PipeIn.Read(&BufferRead);
  Status = PipeIn.WaitForCompletion(&BufferRead,100);
  // si status = ok , leo el valor
  if (Status == USBIO_ERR_SUCCESS) 
			 return true;
  else return false;
}


/* Rutina de calibracion de balanza */

void CBalanzausbDlg::OnCal() 
{
	unsigned char medicion;
	int status;
	CFile m_file;

	KillTimer(ID_COUNT_TIMER);			// desactivo los timers
	KillTimer(ID_TIMER_TRABAJO);
	
	if (UpdateData(TRUE))				// actualizo variables con valores en pantalla
	{
	m_file.Open("c:\\balusb\\usb.ini",CFile::modeCreate | CFile::modeWrite,NULL);  // abro archivo de configuracion
	
	m_BEmpezarTrabajo.EnableWindow(FALSE);	// Apago boton de trabajo	
	
	status=MessageBox("Despeje la balanza,se tomara el cero","Calibracion de Balanza",MB_OKCANCEL | MB_ICONEXCLAMATION);
	if (status == IDOK)
	{
		cero=LeoPesoEst();  // Tomo medicion del cero (balanza vacia)
		
		status=MessageBox("Ponga el peso patron sobre la balanza","Calibracion de Balanza",MB_OKCANCEL | MB_ICONEXCLAMATION);
		if (status == IDOK)
		{ 
			medicion=LeoPesoEst();  // Tomo medicion del peso patron
			coef= (float)((float)m_PesoPat / ((float)medicion-(float)cero));  // calculo coeficiente = peso patron real / (peso patron medido - cero medido)
			m_file.Write(&coef,sizeof(coef));				// guardo coeficiente en archivo 
			m_file.Write(&m_PesoPat,sizeof(m_PesoPat));		// guardo peso patron real en archivo
			m_file.Write(m_lim,sizeof(m_lim));				// guardo limites actuales en archivo 
			m_file.Close();									// cierro archivo	
			MessageBox("Calibracion OK!","Calibracion de Balanza",MB_OK | MB_ICONINFORMATION);
		}
	
	}

	if(status == IDCANCEL)
		MessageBox("Calibracin cancelada!","Calibracion de Balanza",MB_OK | MB_ICONSTOP);	
	
	m_BEmpezarTrabajo.EnableWindow(TRUE);
	}
}

/* Rutina de prueba de calibracion */

void CBalanzausbDlg::OnPrueba() 
{
	
	MessageBox("Despeje la balanza,se tomara el cero","Prueba de Balanza",MB_OK | MB_ICONEXCLAMATION);
	cero=LeoPesoEst();						// Tomo el cero
	SetTimer(ID_COUNT_TIMER,100,NULL);		// habilito timer. LLama a la rutina de mostrar cada 100 ms
	m_BPararPrueba.EnableWindow(TRUE);		// activo boton de parar prueba
	m_BPrueba.EnableWindow(FALSE);			// desactivo botones de prueba. calibracion y trabajo
	m_BCalib.EnableWindow(FALSE);
	m_BEmpezarTrabajo.EnableWindow(FALSE);

}

/* Rutina para parar prueba de calibracion */

void CBalanzausbDlg::OnStopCal() 
{
	KillTimer(ID_COUNT_TIMER);				// desactivo timer
	m_sCuentas = _T("0");					// Pongo en cero los casilleros de cuentas y gramos
	m_sPeso = _T("0");
	m_BPararPrueba.EnableWindow(FALSE);		// habilito botones y deshabilito
	m_BPrueba.EnableWindow(TRUE);
	m_BCalib.EnableWindow(TRUE);
	m_BEmpezarTrabajo.EnableWindow(TRUE);
	UpdateData(FALSE);						// actualizo pantalla

}

/* Rutina de Atencion de los timers */

void CBalanzausbDlg::OnTimer(UINT nIDEvent) 
{
	unsigned char medicion,peso_neto;
	float gramos;

	switch(nIDEvent)				
	{
	// Timer para prueba de calibracion (100 ms)
	case ID_COUNT_TIMER:
						medicion = LeoPesoEst();		// Realizo medicion estatica
						peso_neto = medicion - cero;	// Le resto el cero , obtengo peso neto en cuentas

						gramos = coef * (float)peso_neto;	// lo paso a gramos , multiplico por coeficiente

						m_sPeso.Format("%.0f",gramos);		// actualizo variables de pantalla de gramos y cuentas
						m_sCuentas.Format("%u",medicion);

						UpdateData(FALSE);				  // actualizo pantalla
						break;
	
	// Timer para trabajo (100 ms)
	case ID_TIMER_TRABAJO:
						
						if (LeoUsb())						// leo usb , si es true el buffer esta lleno
						{   

							char i=10;						
							
								// leo primer byte = status del dispositivo

							if(*ptr == 0)					// status 0 = Espera sincronismo (indice)				
								m_sStatus.Format("Esperando sincronismo...");	
							if(*ptr == 1)					// status 1 = Tomando taras
								m_sStatus.Format("Tomando Taras");

							if(*ptr == 2)					// status 2 = Trabajando
							{
								m_sStatus.Format("Trabajando");

								switch(*(ptr+3))			// Byte 3 = salida abierta , un bit por cada salida
								{							// lo paso a numero de bit 0-7
								case 1:	i=0;
										break;
								case 2:	i=1;
										break;
								case 4: i=2;
										break;
								case 8: i=3;
										break;
								case 16: i=4;
										break;
								case 32: i=5;
										break;
								case 64: i=6;
										break;
								case 128: i=7;
										break;
								}

								if (i!=10)				// si cambio i (vale de 0-7) actualizo estadistica
								{
									m_Cant[i] += 1;							// sumo 1 a cantidad segun salida abierte
									m_sCant[i].Format("%u",m_Cant[i]);		// formateo variable de pantalla
									medicion = *(ptr+1);					// leo medicion neta (byte 1 del buffer)
									m_Gramos[i] +=  medicion * coef / 1000;		// lo paso a Kilos y lo acumulo segun salida
									m_sGramos[i].Format("%.2f",m_Gramos[i]);    // formateo variable de pantalla
							

									m_Cant[8] += 1;								// incremento totales
									m_Gramos[8] +=  medicion * coef / 1000;

									m_sCant[8].Format("%u",m_Cant[8]);
									m_sGramos[8].Format("%.2f",m_Gramos[8]);
									grabar = true;								

								}
								
							}
						}
						UpdateData(FALSE);			// actualizo pantalla
						break;

	
	}

	CDialog::OnTimer(nIDEvent);
}

/* Rutina para guardar limites en archivo */

void CBalanzausbDlg::OnGuardLim() 
{

	CFileDialog m_fileDialog(FALSE);
	CFile m_file;
	unsigned char *ptr;	
	DWORD Status;

	// Filtros para dialogo

	static char BASED_CODE szFilter[] = "Archivos Lmites USB(*.lim)\0*.lim\0Todos los archivos(*.*)\0*.*\0";
	static char BASED_CODE szExt[] = ".lim";
	
	// puntero a buffer
	ptr = (unsigned char*)BufferWrite.Buffer();

	if(UpdateData(TRUE))	// actualizo variables segun pantalla
	{
	for(char i=0;i<7;i++)			// Compruebo coherencia en limites (de menor a mayor)
		if (m_lim[i] > m_lim[i+1])
		{	
			MessageBox("Error en limites");
			return;
		}

	// Inicilizo estructura para abrir archivo (directorio y filtros)
		
	m_fileDialog.m_ofn.lpstrInitialDir = "C:\\balusb\\";	
	m_fileDialog.m_ofn.lpstrDefExt = szExt;
	m_fileDialog.m_ofn.lpstrFilter = szFilter;

	if (m_fileDialog.DoModal() == IDOK)		// Abro dialogo
	{
		m_file.Open(m_fileDialog.GetFileName(),CFile::modeCreate | CFile::modeWrite,NULL);   // Creo archivo
		m_file.Write(m_lim,sizeof(m_lim));	// guardo limites
		m_file.Close();		// cierro archivo

		BufferWrite.NumberOfBytesToTransfer = 16;		// transfiero los limites al disp USB
		*ptr = 2;
		for (i=0;i<8;i++)
			*(ptr+i+1) = (unsigned char) ((float)m_lim[i]/coef);

		PipeOut.Write(&BufferWrite);
		Status = PipeOut.WaitForCompletion(&BufferWrite,200);
		if(Status == USBIO_ERR_SUCCESS)
			MessageBox("Nuevos Limites guardados y enviados");
		else MessageBox("No pudo enviarse","Enviar limites",MB_OK | MB_ICONSTOP);

		m_file.Open("c:\\balusb\\usb.ini",CFile::modeCreate | CFile::modeWrite,NULL);  // Los guardo tambien en archivo de configuracion
		m_file.Write(&coef,sizeof(coef));
		m_file.Write(&m_PesoPat,sizeof(m_PesoPat));
		m_file.Write(m_lim,sizeof(m_lim));
		m_file.Close();
	}

	else MessageBox("Cancelado","Enviar limites",MB_OK | MB_ICONSTOP);
	}
}

/* Rutina para cargar limites desde archivo */

void CBalanzausbDlg::OnCargaLim() 
{

	CFileDialog m_fileDialog(TRUE);
	CFile m_file;
	static char BASED_CODE szFilter[] = "Archivos Lmites USB(*.lim)\0*.lim\0Todos los archivos(*.*)\0*.*\0";
	static char BASED_CODE szExt[] = ".lim";
	DWORD Status;
	unsigned char *ptr;

	ptr = (unsigned char*)BufferWrite.Buffer();	

	m_fileDialog.m_ofn.lpstrInitialDir = "C:\\balusb\\";
	m_fileDialog.m_ofn.lpstrFilter = szFilter;
	m_fileDialog.m_ofn.lpstrDefExt = szExt;


	if (m_fileDialog.DoModal() == IDOK)
	{
		m_file.Open(m_fileDialog.GetFileName(),CFile::modeRead,NULL); // abro archivo
		m_file.Read(m_lim,sizeof(m_lim)); // leo limites
		m_file.Close();
		UpdateData (FALSE); // actualizo pantalla 
	

		BufferWrite.NumberOfBytesToTransfer = 16;	// transfiero limites al disp USB
		*ptr = 2;
		for (char i=0;i<8;i++)
			*(ptr+i+1) = (unsigned char) ((float)m_lim[i]/coef);

		PipeOut.Write(&BufferWrite);
		Status = PipeOut.WaitForCompletion(&BufferWrite,300);
		if(Status == USBIO_ERR_SUCCESS)
			MessageBox("Nuevos Limites guardados y enviados");
		else MessageBox("No pudo enviarse","Enviar limites",MB_OK | MB_ICONSTOP);
	}

	else MessageBox("Cancelado","Enviar limites",MB_OK | MB_ICONSTOP);
}

/* Rutina para guardar Estadisticas en archivo */

void CBalanzausbDlg::OnGuarEstad() 
{
	
	CFileDialog m_fileDialog(FALSE);
	CString m_sTime;
	CTime curTime = CTime::GetCurrentTime();

	// Filtros
	static char BASED_CODE szFilter[] = "Archivos Estadsticas USB(*.est)\0*.est\0Todos los archivos(*.*)\0*.*\0";
	static char BASED_CODE szExt[] = ".est";
	// Nombres de dias de la semana
	char *Dia[7]={"Domingo","Lunes","Martes","Mircoles","Jueves","Viernes","Sbado"};

	FILE *arc;

	UpdateData(TRUE);

	m_fileDialog.m_ofn.lpstrInitialDir = "C:\\balusb\\";
	m_fileDialog.m_ofn.lpstrDefExt = szExt;
	m_fileDialog.m_ofn.lpstrFilter = szFilter;

	if (m_fileDialog.DoModal() == IDOK)	// Abro dialogo
	{
		
	arc=fopen(m_fileDialog.GetFileName(),"w"); // abro archivo
	
	
	// Le agrego fecha y hora
	m_sTime.Format("%s %02d/%02d/%d  %02d:%02d:%02d",Dia[curTime.GetDayOfWeek()-1],curTime.GetDay(),curTime.GetMonth(),curTime.GetYear(),curTime.GetHour(),curTime.GetMinute(),curTime.GetSecond());
	fprintf(arc,"Archivo de Estadsticas\n%s\n\n",m_sTime); 
	
	// Guardo estadisticas

	for(char i=0;i<8;i++)
			fprintf(arc,"Linea %d:   %s Unidades    %s Kilogramos\n",i,m_sCant[i],m_sGramos[i]);

	fprintf(arc,"\nTotales:   %s Unidades    %s Kilogramos",m_sCant[8],m_sGramos[8]);
			
	fclose(arc); // cierro archivo
	
	}
	
}

/* Rutina para inicializar estadisticas a 0 */

void CBalanzausbDlg::InitEstad()
{
	m_sCant[0] = _T("0");
	m_sCant[1] = _T("0");
	m_sCant[2] = _T("0");
	m_sCant[3] = _T("0");
	m_sCant[4] = _T("0");
	m_sCant[5] = _T("0");
	m_sCant[6] = _T("0");
	m_sCant[7] = _T("0");
	m_sCant[8] = _T("0");
	m_sGramos[0] = _T("0");
	m_sGramos[1] = _T("0");
	m_sGramos[2] = _T("0");
	m_sGramos[3] = _T("0");
	m_sGramos[4] = _T("0");
	m_sGramos[5] = _T("0");
	m_sGramos[6] = _T("0");
	m_sGramos[7] = _T("0");
	m_sGramos[8] = _T("0");

	m_Cant[0] = 0;
	m_Cant[1] = 0;
	m_Cant[2] = 0;
	m_Cant[3] = 0;
	m_Cant[4] = 0;
	m_Cant[5] = 0;
	m_Cant[6] = 0;
	m_Cant[7] = 0;
	m_Cant[8] = 0;
	m_Gramos[0] = 0;
	m_Gramos[1] = 0;
	m_Gramos[2] = 0;
	m_Gramos[3] = 0;
	m_Gramos[4] = 0;
	m_Gramos[5] = 0;
	m_Gramos[6] = 0;
	m_Gramos[7] = 0;
	m_Gramos[8] = 0;

	
	
}

/* Rutina para comenzar trabajo */

void CBalanzausbDlg::OnEmpezar() 
{	
	SetTimer(ID_TIMER_TRABAJO,100,NULL);  // Setea timer de 100 ms
	m_BCalib.EnableWindow(FALSE);		  // Habilito botones de parar trabajo y reempezar
	m_BPrueba.EnableWindow(FALSE);			// Habilito botones de prueba y calibracion
	m_BPararTrabajo.EnableWindow(TRUE);
	m_BEmpezarTrabajo.EnableWindow(FALSE);
	m_BReempezar.EnableWindow(TRUE);
	
}

/* Rutina para detener trabajo */

void CBalanzausbDlg::OnStopTrabajo() 
{
	m_sStatus = _T("");					 // Borro status en pantalla
	KillTimer(ID_TIMER_TRABAJO);		// Desactivo timer de 100 ms
	m_BCalib.EnableWindow(TRUE);
	m_BPrueba.EnableWindow(TRUE);
	m_BPararTrabajo.EnableWindow(FALSE);
	m_BEmpezarTrabajo.EnableWindow(TRUE);
	m_BReempezar.EnableWindow(FALSE);
}

/* Rutina para reempezar trabajo (tomar taras otra vez) */

void CBalanzausbDlg::OnReempezar() 
{
 	DWORD Status;
	unsigned char *ptr;

	ptr = (unsigned char*)BufferWrite.Buffer();	
	
	BufferWrite.NumberOfBytesToTransfer = 16;  // Envio comando 3 para tomar taras otra vez
	*ptr = 3;								 // al disp USB	
	
	PipeOut.Write(&BufferWrite);
	Status = PipeOut.WaitForCompletion(&BufferWrite,100);
	if(Status != USBIO_ERR_SUCCESS)
			MessageBox("No pudo enviarse el comando","Reempezar",MB_OK | MB_ICONSTOP);
	
}

/* Rutina para configuracion de coeficientes y limites desde archivo al cargar la aplicacion */

bool CBalanzausbDlg::Configurar()
{
	CFile m_file;
	

	if (!m_file.Open("c:\\balusb\\usb.ini",CFile::modeRead,NULL))  // Abro archivo de conf
			return false;
	

	else 
	{
		m_file.Read(&coef,sizeof(coef));							// Leo datos
		m_file.Read(&m_PesoPat,sizeof(m_PesoPat));
		m_file.Read(m_lim,sizeof(m_lim));
		m_file.Close();
		UpdateData(FALSE);											// actualizo pantalla		
				
		return true;

	}

}

/* Rutina para reset de estadisticas */

void CBalanzausbDlg::OnResetEstad() 
{
		if(MessageBox("Se borraran los datos , quiere continuar?","Reset de Estadsticas",MB_OKCANCEL | MB_ICONEXCLAMATION) == IDOK)
		{
			InitEstad();				// Borro todo a 0
			UpdateData(FALSE);
			grabar = false;
		}
	
}

/* Rutina para salir del programa */

void CBalanzausbDlg::OnExit() 
{
	CFile m_file;
	int mensaje;

	if (configurado == true)	
	{
		if (grabar == true)		// Para no perder las estadisticas , si estaba trabajando
			mensaje=MessageBox("Se perdern las estadsticas. Desea guardarlas antes de salir?","Salir de Balanza USB",MB_YESNOCANCEL | MB_ICONEXCLAMATION);

		else					// Confirmacion
			mensaje=MessageBox("Desea salir del programa?","Salir de Balanza USB",MB_OKCANCEL | MB_ICONEXCLAMATION);
	
		
		if(mensaje != IDCANCEL)
		{
			UpdateData(TRUE);
			if(mensaje == IDYES)
					OnGuarEstad();	// Guardo estadisticas
		
			// Guardo coeficientes y limites en archivo de configuracion

			m_file.Open("c:\\balusb\\usb.ini",CFile::modeCreate | CFile::modeWrite,NULL); 
			m_file.Write(&coef,sizeof(coef));
			m_file.Write(&m_PesoPat,sizeof(m_PesoPat));
			m_file.Write(m_lim,sizeof(m_lim));
			m_file.Close();
			
			PipeIn.Close();			// Cierro pipes
			PipeOut.Close();
			Disp.Close();			// Cierro dispositivo USB
			CUsbIo::DestroyDeviceList(g_DevList);	 // Destruyo lista de dispositivos
			OnOK();	
		}
	}

	else 
	{
		PipeIn.Close();
		PipeOut.Close();
		Disp.Close();
		CUsbIo::DestroyDeviceList(g_DevList);	
		OnOK();
	}
}
